<template>
    <div>
        <el-alert
          title="采集一个商品添加进草稿箱，将消耗20金币"
          type="success"
          :closable="false" style="margin-bottom: 10px;">
        </el-alert>
        <el-form class="ai-form" :model="form" label-width="150px" ref="form">
            <el-form-item v-if="!isMultiCopy" label="商品地址：" style="width: 100%;" prop="url" :rules="[{ required: true, message: '请输入商品地址', trigger: 'blur' }]">
              <el-input type="textarea" :rows="5" v-model="form.url"></el-input>
            </el-form-item>
            <el-form-item label="店铺：" style="width: 100%;" prop="targetMallId" :rules="[{ required: true, message: '请选择店铺', trigger: 'blur' }]">
            <el-select style="width: 380px" v-model="form.targetMallId" placeholder="请选择">
                <el-option
                v-for="item in $store.state.mallList"
                :key="item.mallId"
                :label="item.mallName"
                :value="item.mallId">
                </el-option>
            </el-select>
            </el-form-item>
            <el-form-item label="商品分类：" style="width: 100%;" prop="targetCatId" :rules="[{ required: true, message: '请选择商品分类', trigger: 'blur' }]">
            <ai-lazy-cascader 
              style="width: 380px" 
              v-model="form.targetCatId" 
              filterable
              :props="props"></ai-lazy-cascader>
            </el-form-item>
        </el-form>
        <div class="bottom flex-center">
            <el-button @click="$emit('onClose')">取 消</el-button>
            <el-button type="primary" @click="toAddToDraft" :loading="isCopying">确定</el-button>
        </div>
    </div>
</template>

<script>
import {sendChromeAPIMessage, sendChromeWebReqMessage} from '@/api/chromeApi'
import AiLazyCascader from "@/components/AiLazyCascader.vue"
import { getImageMd5, uploadImage } from "@/utils/image.js"
import { extractImagesAndText } from "@/utils/html.js"
import { transformAliExpress } from "@/utils/product.js"
import { formatDate } from "@/utils/date.js"
import { createFolderApi } from "@/utils/folder.js"
import { Message } from 'element-ui'
import { MessageBox } from 'element-ui';

export default {
    name: 'AiCopyFromTemu',
    props: ['params', 'isMultiCopy'],
    components: {AiLazyCascader},
    data() {
        return {
            props: {
                value: 'catId',
                label: 'catName',
                lazy: true,
                lazyLoad (value, resolve) {
                    sendChromeAPIMessage({
                        url: 'bg-anniston-mms/category/children/list',
                        needMallId: true,
                        data: {
                            parentCatId: value || ''
                        }
                    }).then(res => {
                        if (res.errorCode === 1000000) {
                            resolve(res.result.categoryNodeVOS.map(v => {
                            return {
                                ...v,
                                leaf: v.isLeaf
                            }
                            }))
                        }
                    })
                },
                lazySearch(queryString, resolve) {
                  sendChromeAPIMessage({
                    url: 'bg-anniston-mms/category/search',
                    needMallId: true,
                    data: {
                      searchText: queryString || ''
                    }
                  }).then(res => {
                    if (res.errorCode === 1000000) {
                      resolve(res.result.categoryPaths.map(v => {
                        let value = []
                        let label = []
                        for (let i = 1; i <= 10; i++ ) {
                          if (v['cat'+i+'NodeVO']) {
                            value.push(v['cat'+i+'NodeVO'].catId)
                            label.push(v['cat'+i+'NodeVO'].catName)
                          }
                        }
                        return {
                          catId: value,
                          catName: label
                        }
                      }))
                    }
                  })
                }
            },
            form: {
                url: '',
                type: 2,  // 默认从temu复制
                targetMallId: '',
                targetCatId: []
            },
            goods: {},
            sku: {},
            productDetail: {},
            isCopying: false,
            goodsId: '',
            currentUrl: '',
            goodsProperty: [],
            catId: null,
            currentIndex: 0,
            successList: []
        }
    },
    created () {
      if (this.params?.url) {
        this.form.url = this.params.url
      }
    },
    methods: {
      toAddToDraft() {
        this.$refs.form.validate((valid) => {
          if (valid) {
            this.currentUrl = this.form.url
            this.addToDraft()
          }
        })
      },
      async addToDraft() {
        // let test = await createFolderApi(formatDate(new Date()).split('-'),this.form.targetMallId)
        this.isCopying = true
        let res = await sendChromeWebReqMessage({
          type: 'aliexpress',
          url: this.currentUrl,
        })
        if (res.indexOf("runParams") == -1) {
          Message.error("请检查地址是否正确，或者“速卖通”网站是否出现滑动条")
          return
        }
        let str = res.substring(res.indexOf("runParams"))
        str = str.substring(0, str.indexOf("<\/script>"))
        str = str.substring(str.indexOf("{"))
        str = str.substring(0, str.lastIndexOf("}"))
        str = str.substring(str.indexOf('data'))
        str = str.substring(5)

        let obj = JSON.parse(str)

        let folderId = await createFolderApi(formatDate(new Date()).split('-'),this.form.targetMallId)
        
        let carouselImageUrls = [], detailImageUrls = []
        let imageConponent = obj.imageComponent
        for (let i = 0; i < imageConponent.imagePathList.length; i++) {
          let img = await uploadImage(folderId, imageConponent.imagePathList[i], this.form.targetMallId)
          carouselImageUrls.push(img)
        }

        let res1 = await sendChromeWebReqMessage({
          type: 'aliexpress',
          url: obj.productDescComponent.descriptionUrl,
        })

        res1 = res1.substring(0, res1.indexOf("<script>"))

        res1 = extractImagesAndText(res1)
        res1 = JSON.parse(res1)
        console.log(res1)
        for (let i = 0; i < res1.images.length; i++) {
          let img = await uploadImage(folderId, res1.images[i], this.form.targetMallId)
          detailImageUrls.push(img)
        }

        this.createDraft(transformAliExpress({
          title: obj.productInfoComponent.subject,
          carouselImageUrls,
          detailImageList: detailImageUrls,
          text: res1.text
        }))
      },
      async createDraft(data) {
        let catId = this.form.targetCatId[this.form.targetCatId.length - 1]
        let res = await sendChromeAPIMessage({
          url: 'bg-visage-mms/product/draft/add',
          needMallId: true,
          mallId: this.form.targetMallId,
          data: {
            catId: catId
        }})
        
        if (res.errorCode == 1000000) {
          let draftId = res.result.productDraftId
          let content = data
          let i = 0
          for (; i < this.form.targetCatId.length; i++) {
            content['cat' + (i+1) + 'Id'] = this.form.targetCatId[i]
          }
          for (; i < 10; i++) {
            content['cat' + (i+1) + 'Id'] = ''
          }

          content.productDraftId = draftId

          this.createProduct(content)
        } else {
          setTimeout(() => {
            this.createDraft(data)
          }, 500)
        }
      },
      createProduct(content) {
        sendChromeAPIMessage({
          url: 'bg-visage-mms/product/draft/save',
          needMallId: true,
          mallId: this.form.targetMallId,
          data: content
        }).then((res) => {
          if (res.errorCode == 1000000) {
            this.successList.push(this.currentUrl)
            this.saveInfo()
            this.isCopying = false
            Message.success("成功添加到草稿箱")
            
          } else {
            setTimeout(() => {
              this.createProduct(content)
            }, 500)
          }
        })
      },
      getSpecIdNew(data) {
        return sendChromeAPIMessage({
          url: 'bg-anniston-mms/sku/spec/byName/queryOrAdd',
          needMallId: true,
          mallId: this.form.targetMallId,
          data: {
            parentSpecId: data.spec_key_id,
            specName: data.spec_value
        }}).then((res) => {
          if (res.errorCode == 1000000) {
            return res
          } else {
            this.getSpecIdNew(data)
          }
        })
      },
      getSpecId(data) {
        return sendChromeAPIMessage({
          url: 'bg-anniston-mms/sku/spec/byName/queryOrAdd',
          needMallId: true,
          mallId: this.form.targetMallId,
          data: {
            parentSpecId: data.specKeyId,
            specName: data.specValue
        }}).then((res) => {
          if (res.errorCode == 1000000) {
            return res
          } else {
            this.getSpecId(data)
          }
        })
      },
      saveInfo() {
        let mallInfo = this.$store.state.mallList.filter(item => {
          return item.mallId == this.form.targetMallId
        })
        this.$http.post('/api/copyProduct/add', {
            mallId: mallInfo[0].mallId,
            mallName: mallInfo[0].mallName,
            url: this.currentUrl,
            type: this.form.type
          }).then(res1 => {
          if (res1.code == 0) {
            this.$store.dispatch('getUserInfo')
            if (!this.isMultiCopy) {
              this.$emit('onSuccess')
            }
          }
        })
      }
    }
}
</script>

<style scoped lang="scss">
.bottom {
    justify-content: center;
  }
</style>